pro verif_heures, file, HEURES=heures, numix1, numix2
;-----------------------------------------------------
; VERIFICATION DES heures demandees: 
;
; Parametres: 	file	structure 
;		heures	heures debut, fin (modifiees a la sortie)
;		numix1	Heure du premier enregistrement
;		numix2	Heure du dernier enregistrement
;

HeurDx=file.heurdeb
HeurFx=file.Heurfin

TIME = lonarr(2)

IF NOT KEYWORD_SET(heures) THEN BEGIN
    TIME(0)=HeurDx
    TIME(1)=HeurFx  
ENDIF ELSE BEGIN 
    TIME(0) = hms(heures(0)) 
    TIME(1) = hms(heures(1)) 
ENDELSE 

IF (TIME(0) LT HeurDx) THEN  TIME(0) = HeurDx
IF (TIME(1) GT HeurFX) THEN  TIME(1) = HeurFx

;* ---------------------------------------------------------------- *
;*	Calcul de l'indice de la premiere et derniere images        *
;*	corespondant a l'intervalle de temps demande ainsi          *
;*	que le temps exact de debut et de fin de l'intervalle       *
;* ---------------------------------------------------------------- *
; 

hdeb= FLOAT(HeurDx)		; conversion de l'heure de debut en reel
dtx=file.paspix(1)		; Pas temporel entre deux images
;IF TIME(0) LT hdeb THEN BEGIN 
;   numix1 = 0
;   tempx1 = HeurDx
;ENDIF ELSE BEGIN
   numix1= INDICE(hdeb,TIME(0),dtx,tempx1) ; Indice et temps exact de l'image
;ENDELSE

hfin= FLOAT(HeurFx)                     ; conversion de l'heure de fin en reel
;IF TIME(1) GT hfin THEN BEGIN
;   numix2 = s(2)-1
;   tempx2 = HeurFx
;ENDIF ELSE BEGIN
   numix2= INDICE(hdeb,TIME(1),dtx,tempx2) ; Indice et temps exact de l'image
;ENDELSE

heures = [MSH(tempx1), MSH(tempx2)]

RETURN
END