;+ ***********************************************************************
; NAME:
;	DELFPOS
;
; PURPOSE:
;	Detruit les fichiers utilises par le module de recherche de positions
;
; CATEGORY:
;	RH_2D, Recherche de position
;
; CALLING SEQUENCE:
;	DELFPOS, Fich1, Fich2, Fich3
;
; OPTIONAL INPUTS:
;	Fich1:	nom du fichier binaire contenant les sources
;	Fich2:	nom du fichier binaire contenant les sources triees
;	Fich3:	nom du fichier fits temporaire des positions
;
; MODIFICATION HISTORY:
;	Ecrit par: C. Reni 08/1998
;-*******************************************************************



PRO DELFPOS, fichsources, fichposi, fichfits

	command = 'rm -f'
	r = FINDFILE(fichsources)
	IF r(0) EQ fichsources THEN command = command + ' ' + fichsources
	r = FINDFILE(fichposi)
	IF r(0) EQ fichposi THEN command = command + ' ' + fichposi
    	r = FINDFILE(fichfits)
	IF r(0) EQ fichfits THEN command = command + ' ' + fichfits

	IF STRLEN(command) GT 5 THEN SPAWN, command

END
