;---------------------------------------------------------------------
;                            rh_hfin
;---------------------------------------------------------------------
; Determine klu pour l'heure demandee. 
;
; CALLING SEQUENCE: 
;       rh_hfin, heur, klu, heurlu 
; 
; INPUTS:
;       heur : 		heure cherchee			intarr(4)
;
; OUTPUTS: 
;	klu: 		no d'acquisition correspondant a l'heure cherchee 
;	     		= -1L si heure non trouvee
;	heurlu:		heure correspondant a klu
;
; COMMON BLOCKS: 
;       RH 
;-----------------------------------------------------------------------  

PRO rh_hfin, heur, klu, hlu

@rh_common.inc

  rh_hdeb, heur, klu, hlu
  IF rh_hcent(hlu) LT rh_hcent(heur) THEN BEGIN
     klu  = (klu+1L) < entfi.klumax
     hlu = RH_READH(klu)
  ENDIF
  RETURN
END
